"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/effects/cube-slider.ts
var cube_slider_exports = {};
__export(cube_slider_exports, {
  default: () => CubeSlider
});
module.exports = __toCommonJS(cube_slider_exports);

// src/utils.ts
function applyCss(el, styles) {
  Object.keys(styles).forEach((key) => el.style.setProperty(key, styles[key]));
}

// src/effects/cube-slider.ts
var CubeSlider = class {
  options;
  translateZ;
  constructor(options) {
    this.options = {
      direction: options?.direction || "horizontal",
      perspective: options?.perspective || 1e3
    };
  }
  initialize(el, slides, options, stateStore) {
    const width = el.offsetWidth;
    const height = el.offsetHeight;
    const perspective = `${this.options.perspective}px`;
    const viewport = el.parentElement;
    if (viewport == null) {
      throw new Error("Unable to locate viewport element for Cube slider");
    }
    this.translateZ = this.options.direction === "vertical" ? height / 2 : width / 2;
    stateStore.storeAttributes(viewport, ["style"]);
    slides.forEach(
      (slide) => applyCss(slide, {
        left: "0",
        position: "absolute",
        top: "0"
      })
    );
    applyCss(el, {
      left: "0",
      overflow: "visible",
      position: "absolute",
      top: "0"
    });
    if (!["absolute", "fixed", "relative"].includes(
      getComputedStyle(viewport).position
    )) {
      applyCss(viewport, { position: "relative" });
    }
    applyCss(viewport, {
      overflow: "visible",
      perspective
    });
    applyCss(slides[options.startIndex ?? 0], {
      transform: `${this.rotation(0)} translate3d(0,0,${this.translateZ}px)`
    });
    applyCss(el, {
      "transform-style": "preserve-3d",
      transform: `translate3d(0,0,-${this.translateZ}px)`
    });
  }
  async transition(settings) {
    const angle = settings.isPrevious ? 90 : -90;
    applyCss(settings.slides[settings.nextIndex], {
      transform: `${this.rotation(-angle)} translate3d(0,0,${this.translateZ}px)`
    });
    await settings.el.animate(
      {
        transform: `translate3d(0,0,-${this.translateZ}px) ${this.rotation(angle)}`
      },
      {
        duration: settings.speed
      }
    ).finished;
    settings.slides.forEach((s, index) => {
      if (index !== settings.nextIndex) {
        applyCss(s, { transform: "initial" });
      }
    });
    applyCss(settings.slides[settings.nextIndex], {
      transform: `${this.rotation(0)} translate3d(0,0,${this.translateZ}px)`
    });
    applyCss(settings.el, {
      transform: `translate3d(0,0,-${this.translateZ}px)`
    });
  }
  rotation(angle) {
    return `rotate3d(${this.options.direction === "vertical" ? "1, 0, 0" : "0, 1, 0"}, ${angle}deg)`;
  }
};
