"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/effects/fade-slider.ts
var fade_slider_exports = {};
__export(fade_slider_exports, {
  default: () => FadeSlider
});
module.exports = __toCommonJS(fade_slider_exports);

// src/utils.ts
function applyCss(el, styles) {
  Object.keys(styles).forEach((key) => el.style.setProperty(key, styles[key]));
}

// src/effects/fade-slider.ts
var FadeSlider = class {
  options;
  constructor(options) {
    this.options = {
      timingFunction: options?.timingFunction || "ease-in"
    };
  }
  initialize(el, slides, options) {
    if ("static inherit".includes(getComputedStyle(el).position)) {
      applyCss(el, { position: "relative" });
    }
    slides.forEach((slide, index) => {
      const active = index === options.startIndex;
      applyCss(slide, {
        height: "100%",
        left: "0",
        opacity: active ? "1" : "0",
        position: "absolute",
        top: "0",
        width: "100%",
        "z-index": active ? "2" : "1"
      });
    });
  }
  async transition({
    currentIndex,
    nextIndex,
    slides,
    speed
  }) {
    const currentSlide = slides[currentIndex];
    const nextSlide = slides[nextIndex];
    applyCss(currentSlide, { "z-index": "1" });
    applyCss(nextSlide, { "z-index": "2" });
    await Promise.all([
      currentSlide.animate(
        { opacity: [1, 0] },
        {
          duration: speed,
          easing: this.options.timingFunction,
          fill: "forwards"
        }
      ).finished,
      nextSlide.animate(
        { opacity: [0, 1] },
        {
          duration: speed,
          easing: this.options.timingFunction,
          fill: "forwards"
        }
      ).finished
    ]);
  }
  destroy(_, slides) {
    slides.forEach((slide) => {
      slide.getAnimations().forEach((animation) => animation.cancel());
    });
  }
};
