import type { StateStore } from '../state-store';
import type { BoxSliderOptions, Effect, TransitionSettings } from '../types';
export interface CubeSliderOptions {
    direction?: 'horizontal' | 'vertical';
    perspective?: number;
}
export default class CubeSlider implements Effect {
    readonly options: CubeSliderOptions;
    private translateZ;
    constructor(options?: Partial<CubeSliderOptions>);
    initialize(el: HTMLElement, slides: HTMLElement[], options: BoxSliderOptions, stateStore: StateStore): void;
    transition(settings: TransitionSettings): Promise<void>;
    private rotation;
}
