import type { BoxSliderOptions, Effect, TransitionSettings } from '../../types';
export type TileEffect = 'flip' | 'fade';
export interface TileSliderOptions {
    rowOffset: number;
    rows: number;
    tileEffect: TileEffect;
}
export declare const defaultOptions: TileSliderOptions;
export default class TileSlider implements Effect {
    readonly options: TileSliderOptions;
    private _tileWrapper;
    private tileTransition;
    private grid;
    private activeFace;
    get tileWrapper(): HTMLElement;
    constructor(options?: Partial<TileSliderOptions>);
    initialize(el: HTMLElement, slides: HTMLElement[], options: BoxSliderOptions): void;
    transition(settings: TransitionSettings): Promise<void>;
    destroy(): void;
    private calculateGrid;
}
