import type { BoxSliderOptions } from './types';
import { type FadeSliderOptions } from './effects/fade-slider';
import { type CarouselSliderOptions } from './effects/carousel-slider';
import { type CubeSliderOptions } from './effects/cube-slider';
import { type TileSliderOptions } from './effects/tile/tile-slider';
import BoxSlider from './box-slider';
export declare function getSliderElement(el: string | HTMLElement): HTMLElement;
export type CreateCarouselSliderOptions = Partial<BoxSliderOptions> & CarouselSliderOptions;
export declare function createCarouselSlider(el: string | HTMLElement, options?: CreateCarouselSliderOptions): BoxSlider;
export type CreateCubeSliderOptions = Partial<BoxSliderOptions> & CubeSliderOptions;
export declare function createCubeSlider(el: string | HTMLElement, options?: CreateCubeSliderOptions): BoxSlider;
export type CreateFadeSliderOptions = Partial<BoxSliderOptions> & FadeSliderOptions;
export declare function createFadeSlider(el: string | HTMLElement, options?: CreateFadeSliderOptions): BoxSlider;
export type CreateTileSliderOptions = Partial<BoxSliderOptions> & Partial<TileSliderOptions>;
export declare function createTileSlider(el: string | HTMLElement, options?: CreateTileSliderOptions): BoxSlider;
export { BoxSlider, defaultOptions } from './box-slider';
export { default } from './box-slider';
export * from './types';
export * from './effects';
